<!doctype html>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<%@taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@page import="com.sas.svcs.authorization.acl.client.AccessControlEntry" %>
<html>
<head>
<spring:url value="/resources/js/jquery-1.8.0.min.js" var="jquery" />
<script type="text/javascript" src="${jquery}"></script>
<spring:url value="/resources/js/aclbrowser.js" var="acl_js" />
<script type="text/javascript" src="${acl_js}"></script>
<spring:url value="/resources/css/aclbrowser.css" var="acl_css" />
<link rel="stylesheet" style="text/css" href="${acl_css}">
</head>
<body>
	<div id="header">
		<spring:message code="application_name" var="app_name"
				htmlEscape="false" />
		<spring:message code="application_instructions.txt" var="app_instr"
				htmlEscape="false" />
		${app_name}
		<p>${app_instr}</p>
	</div>
	
	
	<!-- <nav class="drop-shadow"> -->
	<c:url var="acl_url" value="/"></c:url>
	<input type='hidden' id='treeModel' value='${treeModel}' />
	<input type="hidden" id="acl_url" value="${acl_url}" />
	<input type="hidden" id="p_url" value="${acl_url}/getPrincipals" />
	
	<div id="navView">
		<div class="content">
			<ul id="nav">
		
			</ul>
		</div>
	</div>
	<div id="aclView">
		<form:form action="${acl_url}" method="POST" modelAttribute="acl">
			<form:hidden path="node.contentObject.objectType" />
			<form:hidden path="node.navigationPath" />
			<form:hidden path="node.contentObject.id" />
			<form:hidden path="node.contentObject.name" />
			<div id="sectionHeader">
				<spring:message code="Properties.header.title" htmlEscape="false" />
			</div>
			<table>
				<tr>
					<spring:message code="NavigationPath.control.label" var="path_label"
						htmlEscape="false" />
					<td><label>${path_label}</label></td>
					<td><span id="objectPath">${acl.node.navigationPath}</span></td>
					<td></td>
					<td></td>
				</tr>
				<tr>
					<spring:message code="ObjectType.control.label" var="object_type_label"
						htmlEscape="false" />
					<td><label>${object_type_label}</label></td>
					<td><span id="objectTypeName">${acl.node.contentObject.objectTypeName}</span></td>
					<td></td>
					<td></td>
				</tr>
				<tr>
					<spring:message code="OwnerType.control.label" var="owner_type_label"
						htmlEscape="false" />
					<td><label>${owner_type_label}</label></td>
					<td><form:select path="acl.owner.type">
							<form:options items="${principalTypes}" />
						</form:select></td>
					<spring:message code="Owner.control.label" var="owner_label"
						htmlEscape="false" />
					<td>${owner_label}</td>
					<td><form:select
							path="acl.owner.name">
							<form:options items="${principals}" />
						</form:select></td>
				</tr>
			</table>
			<div id="sectionHeader"><spring:message code="DirectAccess.header.title"
						htmlEscape="false" /></div>
			<div>
			<spring:message code="Inherited.checkbox.label" var="inherited_label"
						htmlEscape="false" />
			<form:checkbox path="acl.inheritable" />
			<label>${inherited_label}</label>
			</div>
			
			<input id="rowIndex" name="rowIndex" type="hidden" value="${fn:length(acl.acl.aces)}" />
			<table id="aceTable">
				<spring:message code="PrincipalType.header.label" var="principal_type_label"
				htmlEscape="false" />
				<spring:message code="PrincipalName.header.label" var="principal_name_label"
				htmlEscape="false" />
				<spring:message code="AdministrationPermission.header.label" var="admin_label"
				htmlEscape="false" />
				<spring:message code="CreatePermission.header.label" var="create_label"
				htmlEscape="false" />
				<spring:message code="ReadPermission.header.label" var="read_label"
				htmlEscape="false" />
				<spring:message code="WritePermission.header.label" var="write_label"
				htmlEscape="false" />
				<spring:message code="DeletePermission.header.label" var="delete_label"
				htmlEscape="false" />
				
				<tr>
					<th>${principal_type_label}</th>
					<th>${principal_name_label}</th>
					<th>${admin_label}</th>
					<th>${create_label}</th>
					<th>${read_label}</th>
					<th>${write_label}</th>
					<th>${delete_label}</th>
					<th></th>
				</tr>
					
				<spring:message code="Remove.tip" var="remove_tip_label"
								htmlEscape="false" />
				<input type="hidden" id="remove_tip_label" value="${remove_tip_label}" />
				
				<c:forEach var="ace" items="${acl.acl.aces}" varStatus="status">
					<tr>
						<td><label>${ace.principal.type}</label><form:hidden path="acl.aces[${status.index}].principal.type" /></td>
						<td><label>${ace.principal.name}</label><form:hidden path="acl.aces[${status.index}].principal.name" /></td>
						<td><form:select
								path="acl.aces[${status.index}].administrationPermission">
								<c:forEach varStatus="loop" items="${permissions}" var="permission">
									<spring:message code="${permission}.txt" var="perm_label"
										htmlEscape="false" />
									<form:option value="${permission}" label="${perm_label}"></form:option>
								</c:forEach>
							</form:select></td>
						<td><form:select
								path="acl.aces[${status.index}].createPermission">
								<c:forEach varStatus="loop" items="${permissions}" var="permission">
									<spring:message code="${permission}.txt" var="perm_label"
										htmlEscape="false" />
									<form:option value="${permission}" label="${perm_label}"></form:option>
								</c:forEach>
							</form:select></td>							
						<td><form:select
								path="acl.aces[${status.index}].readPermission">
								<c:forEach varStatus="loop" items="${permissions}" var="permission">
									<spring:message code="${permission}.txt" var="perm_label"
										htmlEscape="false" />
									<form:option value="${permission}" label="${perm_label}"></form:option>
								</c:forEach>
							</form:select></td>
						<td><form:select
								path="acl.aces[${status.index}].writePermission">
								<c:forEach varStatus="loop" items="${permissions}" var="permission">
									<spring:message code="${permission}.txt" var="perm_label"
										htmlEscape="false" />
									<form:option value="${permission}" label="${perm_label}"></form:option>
								</c:forEach>
							</form:select></td>
						<td><form:select
								path="acl.aces[${status.index}].deletePermission">
								<c:forEach varStatus="loop" items="${permissions}" var="permission">
									<spring:message code="${permission}.txt" var="perm_label"
										htmlEscape="false" />
									<form:option value="${permission}" label="${perm_label}"></form:option>
								</c:forEach>
							</form:select></td>
						<td><input type="button" name="deleteBtn"
							value=" x " title="${remove_tip_label}" /></td>
					</tr>
				</c:forEach>
				<tr>
					<spring:message code="SelectUser.tip" var="select_tip_label"
						htmlEscape="false" />
					<td><select id="principalType" title="${select_tip_label}">
						<spring:message code="Select.action.label" var="select_label"
						htmlEscape="false" />
						<option value="None">${select_label}</option>
						<c:forEach var="type" items="${principalTypes}">
							<option value="${type}">${type}</option>
						</c:forEach>
					</select></td>
					<td><select id="principalName">
						<spring:message code="Select.action.label" var="select_label"
						htmlEscape="false" />
						<option value="None">${select_label}</option>
					</select></td>
					<td><select id="adminPerm">
							<c:forEach var="perm" items="${permissions}">
								<spring:message code="${perm}.txt" var="perm_label"
										htmlEscape="false" />
								<c:choose>
									<c:when test="${perm eq unset}">
										<option value="${perm}" selected="selected">${perm_label}</option>
									</c:when>
									<c:otherwise>
										<option value="${perm}">${perm_label}</option>
									</c:otherwise>
								</c:choose>
							</c:forEach>
					</select></td>
					<td><select id="createPerm">
							<c:forEach var="perm" items="${permissions}">
								<spring:message code="${perm}.txt" var="perm_label"
										htmlEscape="false" />
								<c:choose>
									<c:when test="${perm eq unset}">
										<option value="${perm}" selected="selected">${perm_label}</option>
									</c:when>
									<c:otherwise>
										<option value="${perm}">${perm_label}</option>
									</c:otherwise>
								</c:choose>
							</c:forEach>
					</select></td>
					<td><select id="readPerm">
							<c:forEach var="perm" items="${permissions}">
								<spring:message code="${perm}.txt" var="perm_label"
										htmlEscape="false" />
								<c:choose>
									<c:when test="${perm eq unset}">
										<option value="${perm}" selected="selected">${perm_label}</option>
									</c:when>
									<c:otherwise>
										<option value="${perm}">${perm_label}</option>
									</c:otherwise>
								</c:choose>
							</c:forEach>
					</select></td>
					<td><select id="writePerm">
							<c:forEach var="perm" items="${permissions}">
								<spring:message code="${perm}.txt" var="perm_label"
										htmlEscape="false" />
								<c:choose>
									<c:when test="${perm eq unset}">
										<option value="${perm}" selected="selected">${perm_label}</option>
									</c:when>
									<c:otherwise>
										<option value="${perm}">${perm_label}</option>
									</c:otherwise>
								</c:choose>
							</c:forEach>
					</select></td>
					<td><select id="deletePerm">
							<c:forEach var="perm" items="${permissions}">
								<spring:message code="${perm}.txt" var="perm_label"
										htmlEscape="false" />
								<c:choose>
									<c:when test="${perm eq unset}">
										<option value="${perm}" selected="selected">${perm_label}</option>
									</c:when>
									<c:otherwise>
										<option value="${perm}">${perm_label}</option>
									</c:otherwise>
								</c:choose>
							</c:forEach>
					</select></td>
					<spring:message code="Add.tip" var="add_tip_label"
						htmlEscape="false" />
					<td><input type="button" id="addBtn"
						value=" + " title="${add_tip_label}" /></td>
				</tr>
			</table>
			<br />
			<spring:message code="Save.action.label" var="save_label"
						htmlEscape="false" />
			<spring:message code="Save.tip" var="save_tip_label"
						htmlEscape="false" />
			<input type="submit" value="${save_label}" title="${save_tip_label}"/>
		</form:form>
	</div>
	<!-- </section> -->
</body>
</html>