$(document).ready(function() {
	var model = $.parseJSON($("#treeModel").val());
	var aclUrl = $("#acl_url").val();
	
	$("#nav").append("<ul id='node_root'class='container plus'></ul>");
	buildTree("/", $("#node_root"), model, true);

	function buildTree(name, node, jsonObj, insertNode){
		var obj = jsonObj[name];
		if(insertNode){
			if(node.hasClass('last')){
				node.append("<span><img src='images/minusLastNode.gif'></img>" +
						"<a href='" + aclUrl + "?path=" + obj.path + "&type=" + obj.objectType + "'>"+ obj.name + "</a></span>");
			}else{
				node.append("<span><img src='images/minusNode.gif'></img>" +
						"<a href='" + aclUrl + "?path=" + obj.path + "&type=" + obj.objectType + "'>"+ obj.name + "</a></span>");
			}
		}
		for(var i = 0; i < obj.children.length ; i++)
		{
			for(key in obj.children[i])
			{
				var child = obj.children[i][key];
				var subName = child.name.split(' ').join('_');
				var activeNode = $("#node\\.navigationPath").val();
				if(hasChildren(child)){
					if(i === obj.children.length - 1){
						node.append("<ul id='node_" + subName + "' class='minus last'></ul>");
					}
					else{
						node.append("<ul id='node_" + subName + "' class='minus'></ul>");
					}
					buildTree(subName, $("#node_" + subName), obj.children[i], true);
				}
				else{
					if(i === obj.children.length - 1)
					{
						node.append("<ul id='node_" + subName + "' class='plus last'><span><img src='images/plusLastNode.gif'></img>" +
							"<a href='" + aclUrl + "?path=" + child.path + "&type="+ child.objectType+"'>"+ child.name +"</a></span></ul>");
					}
					else
					{
						node.append("<ul id='node_" + subName + "' class='plus'><span><img src='images/plusNode.gif'></img>" +
								"<a href='" + aclUrl + "?path=" + child.path + "&type="+ child.objectType+"'>"+ child.name +"</a></span></ul>");
					}
				}	
				
				if(activeNode === child.path)
				{
					$("#node_" + subName + " > span > a").first().addClass("active");
				}
			}
		}
	}
	
	function hasChildren(node) {
		if (node.children.length > 0) {
			return true;
		}
		return false;
	}
	
	function clearUserNameList(ownerName)
	{
		$("#" + ownerName +" option").remove();
		var option = $(document.createElement("option"));
		$("#" + ownerName).append(option.val("None").html("Select"));
		return;
	}
	
	function populatePrincipals(ownerType, ownerName)
	{
		var val = $("#"+ ownerType).val();
		if(val == "None")
		{
			clearUserNameList(ownerName);
			return;
		}
		var p_url = $("#p_url").val();
		$.ajax({
			type: 'GET',
			url: p_url,
			data: {
				principalType: val
			},
			success:function(data){
				//alert(data);
				//var user = data.split(",");
				$("#" + ownerName + " option").remove();
				if(data.length > 0)
				{
					for(var i = 0; i< data.length; i++)
					{
						var option = $(document.createElement("option"));
						$("#" + ownerName).append(option.val(data[i]).html(data[i]));
					}
				}
			},
			error:function()
			{
				alert("error");
				return;
			}
		});
	}
	
	
	$("#principalType").change(function(){
		populatePrincipals("principalType", "principalName");
	});
	
	$("#acl\\.owner\\.type").change(function(){
		populatePrincipals("acl\\.owner\\.type", "acl\\.owner\\.name");
	});
	
	$("#addBtn").click(function(){
		var index = $("#rowIndex").val();
		var type = $("#principalType").val();
		var tableIndex = $("#aceTable tr").length - 2;
		var removeLabel = $("#remove_tip_label").val();
		$("#aceTable tr").eq(tableIndex).after("<tr>" +
				"<td>"+ type +
				"<input id='acl.aces"+index+".principal.type' name='acl.aces["+index +"].principal.type' type='hidden' value='"+$("#principalType").val()+"' /></td>" +
				"<td>"+ $("#principalName").val() +
				"<input id='acl.aces"+index+".principal.name' name='acl.aces["+index +"].principal.name' type='hidden' value='"+$("#principalName").val()+"' /></td>" +
				"<td>" +
				"<select id='acl.aces"+index+".administrationPermission' name='acl.aces["+index+"].administrationPermission'>" +
						"</select></td>" +
				"<td>" +
				"<select id='acl.aces"+index+".createPermission' name='acl.aces["+index+"].createPermission'>" +
						"</select></td>" +
				"<td>" +
				"<select id='acl.aces"+index+".readPermission' name='acl.aces["+index+"].readPermission'>" +
						"</select></td>" +
				"<td>" +
				"<select id='acl.aces"+index+".writePermission' name='acl.aces["+index+"].writePermission'>" +
						"</select></td>" +
				"<td>" +
				"<select id='acl.aces"+index+".deletePermission' name='acl.aces["+index+"].deletePermission'>" +
						"</select></td>" +
				"<td><input type='button'"+
							"name='deleteBtn' value=' x ' title='" + removeLabel + "' /></td>" +
				"</tr>");
		copyAllPermissions(index);
		clearRow();
		$("#rowIndex").val(++index);
	});
	
	function clearRow()
	{
		$("#principalType").val("None");
		clearUserNameList("principalName");
		$("#adminPerm").val("UNSET");
		$("#createPerm").val("UNSET");
		$("#readPerm").val("UNSET");
		$("#writePerm").val("UNSET");
		$("#deletePerm").val("UNSET");
	}
	
	function copyAllPermissions(index)
	{
		copyOptions(document.getElementById("adminPerm"), document.getElementById("acl.aces" + index + ".administrationPermission"));
		$("#acl\\.aces"+index+"\\.administrationPermission").val($("#adminPerm").val());
		
		copyOptions(document.getElementById("createPerm"), document.getElementById("acl.aces" + index + ".createPermission"));
		$("#acl\\.aces"+index+"\\.createPermission").val($("#createPerm").val());
		
		copyOptions(document.getElementById("readPerm"), document.getElementById("acl.aces" + index + ".readPermission"));
		$("#acl\\.aces"+index+"\\.readPermission").val($("#readPerm").val());
		
		copyOptions(document.getElementById("writePerm"), document.getElementById("acl.aces" + index + ".writePermission"));
		$("#acl\\.aces"+index+"\\.writePermission").val($("#writePerm").val());
		
		copyOptions(document.getElementById("deletePerm"), document.getElementById("acl.aces" + index + ".deletePermission"));
		$("#acl\\.aces"+index+"\\.deletePermission").val($("#deletePerm").val());
	}
	
	//copy from obj to obj1
	function copyOptions(obj, obj1)
	{
		for(var i = 0; i< obj.options.length; i++)
		{
			var optionElement = document.createElement('option');
			optionElement.value = obj[i].value;
			optionElement.text = obj[i].text;
			optionElement.selected = obj[i].selected;
			obj1.appendChild(optionElement);
			if(obj[i].selected)
				obj1.selectedIndex = i;
		}
		//var optionElement = document.createElement('options');
		//optionElement.innerHTML = obj.innerHTML;
		//obj1.innerHTML = optionElement;
		//alert(obj1.innerHTML);
	}
	
	$(document).on('click', "#navView img", function(e){
		var ulNode = $(this).closest('ul');
		if(ulNode.is('.plus')){
			//alert("expand");
			added = addChildren(ulNode);
			if(added){
				if(ulNode.hasClass('last')){
					ulNode.find("img").first().attr("src", "images/minusLastNode.gif");
				}else{
					ulNode.find("img").first().attr("src", "images/minusNode.gif");
				}
			}else{
				if(ulNode.hasClass('last')){
					ulNode.find("img").first().attr("src", "images/lastNode.gif");
				}else{
					ulNode.find("img").first().attr("src", "images/node.gif");
				}
			}
		}
		else{
			//alert("collapse");
			if(ulNode.hasClass('last')){
				ulNode.find("img").first().attr("src", "images/plusLastNode.gif");
			}else{
				ulNode.find("img").first().attr("src", "images/plusNode.gif");
			}
			ulNode.find('ul').remove();
		}
		ulNode.toggleClass('plus');
	});
	
	$(document).on('click', "input[name='deleteBtn']", function(e){
		$(this).parent().parent().remove();
	});
		
	function addChildren(ulNode)
	{
		var status = true;
		var nodeName = ulNode.attr('id');
		var hrefAttr = (ulNode.find('a').attr('href'));
		var params = hrefAttr.split('?')[1].split('&');
		var path, type;
		for(var i = 0 ; i < params.length ; i++)
		{
			var p1 = params[i].split('=');
			if(p1[0] === 'path')
				path = p1[1];
			else
				type = p1[1];
		}
		$.ajax({
			type: 'GET',
			url: aclUrl + "/getChildren",
			data: {
				path: path,
				type: type
			},
			async: false,
			success: function(result){
				//console.log(result);
				var name = nodeName.split('node_')[1];
				var obj = $.parseJSON(result);
				buildTree(name, ulNode, obj, false);
				if(obj[name].children.length === 0){
					status = false;
				}
			}
		});
		return status;
	}
	
	/*$("#nav a").click(function(e){
		e.preventDefault();
		$("#nav").find('a.active').removeClass('active');
		$(this).addClass('active');
		//get the name from <li> id - ex: node_Applications
		var name = $(this).parent().attr("id").split("node_")[1];
		$.ajax({
			type: 'POST',
			url: aclUrl + "/getAcl",
			data: {
				name: name
			},
			success: function(result){
				console.log(result);
				$("#objectName").text(result.node.contentObject.name);
				$("#objectTypeName").text(result.node.contentObject.objectTypeName);
				$("#objectPath").text(result.node.navigationPath);
				$("#acl\\.owner\\.name").val(result.acl.owner.name);
				$("#acl\\.owner\\.type").val(result.acl.owner.type);
				$("#acl\\.inheritable1").prop("checked", result.acl.inheritable);
			}
		});
	});*/
});
