<!doctype html>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<html>
	<head>
		<spring:url value="/resources/css/smoothness/jquery-ui-1.8.23.custom.css" var="jquery_ui" />
		<link rel="stylesheet" style="text/css" href="${jquery_ui}">
		<spring:url value="/resources/css/templateeditor.css" var="editor" />
		<link rel="stylesheet" style="text/css" href="${editor}">
		
		<spring:url value="/resources/js/jquery-1.8.0.min.js" var="jquery" />
		<script src="${jquery}"></script>
		<spring:url value="/resources/js/templateeditor.js" var="editor_js" />
		<script src="${editor_js}"></script>
		<spring:url value="/resources/js/jquery-ui-1.8.23.custom.min.js" var="jquery_ui_js" />
		<script src="${jquery_ui_js}"></script>
		
		<script type="text/javascript">
			$(document).ready(function(){
				$("#new_dialog").dialog({
					autoOpen: false,
					height: 250,
					width: 450,
					modal: true
				});
			});
			
		</script>
	</head>
	<body>
		<div id="editorView">
		<spring:message code="TemplateEditor.header.title" var="template_title"
			htmlEscape="false" />
		<spring:message code="NotificationTemplates.description.txt" var="template_desc"
			htmlEscape="false" />
		<h2>${template_title}</h2>
		<p>${template_desc}</p>
		<span>
		<spring:message code="NewTemplate.action.label" var="newTemplate_label"
			htmlEscape="false" />
		<spring:message code="DeleteTemplate.action.label" var="deleteTemplate_label"
			htmlEscape="false" />	
		<spring:message code="Refresh.action.label" var="refresh_label"
			htmlEscape="false" />	
		<spring:message code="AddTemplate.tip" var="addTemplate_tip"
			htmlEscape="false" />
		<spring:message code="DeleteTemplate.tip" var="deleteTemplate_tip"
			htmlEscape="false" />	
		<spring:message code="Refresh.tip" var="refresh_tip"
			htmlEscape="false" />
		<spring:message code="DeleteTemplates.txt" var="deleteTemplates_txt"
			htmlEscape="false" />
		
		<spring:url value="/templates" var="template_url"></spring:url>
		<form:form method="POST" modelAttribute="template" id="locale_form">
			<input type="button" id="new_btn" title="${addTemplate_tip}" value=" ${newTemplate_label} " />
			<input type="button" id="delete_btn" title="${deleteTemplate_tip}" value=" ${deleteTemplate_label} " onclick="confirmDelete('${deleteTemplates_txt}');"/>
			<div id="localeDiv">
			<spring:message code="Locale.control.label" var="locale_label"
					htmlEscape="false" />
			<label>${locale_label}</label>
			<form:select path="notificationTemplate.locale">
				<c:forEach varStatus="loop" items="${locales}" var="locale">
					<c:set var="locale_label" value="${locale.displayName}"/>
					<form:option value="${locale}" label="${locale_label}"></form:option>
				</c:forEach>
			</form:select>
			</div>
		</form:form>
		</span>
		<spring:url value="/templates/delete?locale=${template.notificationTemplate.locale}" var="delete_url"></spring:url>
		<form method="POST" id="delete_form" action="${delete_url}">
		<table class="bordered checkboxes">
			<thead>
				<tr>
				<spring:message code="Name.header.label" var="name_label"
					htmlEscape="false" />
				<spring:message code="Locale.header.label" var="locale_label"
					htmlEscape="false" />
				<spring:message code="Version.header.label" var="version_label"
					htmlEscape="false" />
				<spring:message code="CreatedBy.header.label" var="createdBy_label"
					htmlEscape="false" />
				<spring:message code="LastModifiedBy.header.label" var="lastModifiedBy_label"
					htmlEscape="false" />
				<spring:message code="LastModifiedDate.header.label" var="lastModifiedDate_label"
					htmlEscape="false" />
				<spring:message code="SelectAll.tip" var="selectAll_tip"
					htmlEscape="false" />		
				<th><input type="checkbox" id="checkAll" title="${selectAll.tip}"/></th>
				<th>${name_label}</th>
				<th>${locale_label}</th>
				<th>${version_label}</th>
				<th>${createdBy_label}</th>
				<th>${lastModifiedBy_label}</th>
				<th>${lastModifiedDate_label}</th>
				</tr>
			</thead>
			<tbody>
				<c:forEach var="t" items="${templates}" varStatus="row">
				<tr>
					<td class="center"><input type="checkbox" name="templateId" value="${t.id}" /></td>
					<td>
						<a href="templates/${t.name}?locale=${t.locale}">${t.name}</a>
					</td>
					<td class="center">
						${t.locale}
					</td>
					<td class="center">
						${t.version}
					</td>
					<td class="center">
						${t.createdBy}
					</td>
					<td class="center">
						${t.modifiedBy}
					</td>
					<td class="center">
						${t.modifiedDate}
					</td>
				</tr>
				</c:forEach>
			</tbody>
		</table>
		<spring:message code="EditTemplate.txt" var="editTemplate_label"
					htmlEscape="false" />
		${editTemplate_label}
		</form>
		<!-- New Template Dialog -->
		<spring:message code="NewTemplate.header.title" var="newTemplate_label"
			htmlEscape="false" />
		<div id="new_dialog" title="${newTemplate_label}">
			<spring:url value="/templates/create" var="create_url" />
			<form:form method="POST" action="${create_url}">
				<spring:message code="TemplateName.control.label" var="templateName_label"
					htmlEscape="false" />
				<spring:message code="Locale.control.label" var="locale_label"
					htmlEscape="false" />
				<spring:message code="Description.control.label" var="description_label"
					htmlEscape="false" />
				<spring:message code="Save.action.label" var="save_label"
					htmlEscape="false" />
				<spring:message code="Cancel.action.label" var="cancel_label"
					htmlEscape="false" />
				<div>
				<label>${templateName_label}</label><input type="text" name="templateName"/>*
				</div>
				<div>
				<label>${locale_label}</label><input type="text" name="locale" value="${template.notificationTemplate.locale}" readonly="readonly"/>
				</div>
				<div>
				<label>${description_label}</label><input type="text" name="description"/>
				</div>
				<br/>
				<div class="right">
					<input type="submit" value="${save_label}" />
					<input type="button" value="${cancel_label}" onclick="$('#new_dialog').dialog('close');" />
				</div>
			</form:form>
		</div>
		</div>
	</body>
</html>