<!doctype html>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<html>
	<head>
		<spring:url value="/resources/css/smoothness/jquery-ui-1.8.23.custom.css" var="jquery_ui" />
		<link rel="stylesheet" style="text/css" href="${jquery_ui}">
		<spring:url value="/resources/css/templateeditor.css" var="editor" />
		<link rel="stylesheet" style="text/css" href="${editor}">
		
		<spring:url value="/resources/js/jquery-1.8.0.min.js" var="jquery" />
		<script src="${jquery}"></script>
		<spring:url value="/resources/js/jquery-ui-1.8.23.custom.min.js" var="jquery_ui_js" />
		<script src="${jquery_ui_js}"></script>
		<spring:url value="/resources/js/templateeditor.js" var="editor_js" />
		<script src="${editor_js}"></script>
		
		<script type="text/javascript">
			$(document).ready(function(){
				$("#tabs").tabs();
				
				$("#preview_dialog").dialog({
					autoOpen: false,
					height: 400,
					width: 600,
					modal: true,
					beforeClose: function(){
						$("#preview_dialog > p").html("");
					}
				});
				
				$("#test_dialog").dialog({
					autoOpen: false,
					height: 400,
					width: 600,
					modal: true,
					beforeClose: function(){
						$("#msg").html("");
						$("#msg").hide();
					}
				});
			});
		</script>
	</head>
	<body>
		<div id="editorView" class="editor">
			<spring:url value="/templates" var="template_url"></spring:url>
			<input type="hidden" id="template_url" value="${template_url}" />
			<spring:message code="EditTemplate.header.title" var="edit_label" arguments="${template.notificationTemplate.name}"
				htmlEscape="false" />
			<h2>${edit_label}</h2>
			<spring:message code="EditReadonlyTemplate.txt" var="readonly_label" arguments="${template.notificationTemplate.name}"
				htmlEscape="false" />
			<c:if test="${template.readonly}">
				${readonly_label}
			</c:if>
			
			<spring:url value="/templates/save" var="save_url"></spring:url>
			<form:form action="${save_url}" method="POST" modelAttribute="template">
			<table>
				<tr>
					<spring:message code="TemplateName.control.label" var="template_name_label"
					htmlEscape="false" />
					<td><label>${template_name_label}</label></td>
					<td><form:input path="notificationTemplate.name" disabled="true"/> 
					<form:hidden path="notificationTemplate.name" />
					<form:hidden path="notificationTemplate.id" />
					<form:hidden path="readonly" /> </td>
				</tr>
				<tr>
					<spring:message code="Description.control.label" var="description_label"
					htmlEscape="false" />
					<td><label>${description_label}</label></td>
					<td><form:input path="notificationTemplate.description" readonly="${template.readonly}"/> </td>
				</tr>
				<tr>
					<spring:message code="Locale.control.label" var="locale_label"
					htmlEscape="false" />
					<td><label>${locale_label}</label></td>
					<td><form:input path="notificationTemplate.locale" disabled="true"/> 
					<form:hidden path="notificationTemplate.locale"/></td>
				</tr>
				<tr>
					<spring:message code="Version.control.label" var="version_label"
					htmlEscape="false" />
					<td><label>${version_label}</label></td>
					<td>
						<spring:message code="Active.control.label" var="active_label"
						htmlEscape="false" />
						<form:hidden path="activeVersion" />
						<form:select path="notificationTemplate.version">
							<form:options items="${availableVersions}" />
						</form:select> 
						<form:checkbox path="activated" disabled='true'/>
						 <label>${active_label}</label>
					</td>
				</tr>
				<tr>
					<spring:message code="Subject.control.label" var="subject_label"
					htmlEscape="false" />
					<td><label>${subject_label}</label></td>
					<td><form:input path="subjectTemplate" readonly="${template.readonly}"/> </td>
				</tr>
				<tr>
					<spring:message code="TemplateBody.header.label" var="templateBody_label"
					htmlEscape="false" />
					<td><label>${templateBody_label}</label></td>
					<td></td>
				</tr>
			</table>
			
			<!-- HTML & Text Tabs -->
			<div id="tabs">
				<spring:message code="TemplateEditorHTML.tab.title" var="html_label"
					htmlEscape="false" />
				<spring:message code="TemplateEditorText.tab.title" var="text_label"
					htmlEscape="false" />
				<spring:message code="TemplateEditorSMS.tab.title" var="sms_label"
					htmlEscape="false" />
				<spring:message code="HTML.tip" var="html_tip"
					htmlEscape="false" />
				<spring:message code="Text.tip" var="text_tip"
					htmlEscape="false" />
				<spring:message code="SMS.tip" var="sms_tip"
					htmlEscape="false" />
				<ul>
					<li><a href="#htmlTab" title="${html_tip}">${html_label}</a></li>
					<li><a href="#textTab" title="${text_tip}">${text_label}</a></li>
					<li><a href="#smsTab" title="${sms_tip}">${sms_label}</a></li>
				</ul>
				<div id="htmlTab">
					<form:textarea path="htmlTemplate" readonly="${template.readonly}"></form:textarea>
					
					<span>
						<spring:message code="HTMLLetterhead.control.label" var="html_lttr_label"
							htmlEscape="false" />
						<spring:message code="None.control.label" var="none_label"
							htmlEscape="false" />
						<label>${html_lttr_label}</label> 
						<form:select path="notificationTemplate.htmlLetterheadId">
							<form:option value="0" label="${none_label}" />
							<form:options items="${letterheads}" itemValue="id" itemLabel="name" />
						</form:select>
					</span>
				</div>
				<div id="textTab">
					<form:textarea path="textTemplate" readonly="${template.readonly}"></form:textarea>
					<span>
						<spring:message code="TextLetterhead.control.label" var="text_lttr_label"
							htmlEscape="false" />
						<spring:message code="None.control.label" var="none_label"
							htmlEscape="false" />
						<label>${text_lttr_label}</label> 
						<form:select path="notificationTemplate.txtLetterheadId">
							<form:option value="0" label="${none_label}" />
							<form:options items="${letterheads}" itemValue="id" itemLabel="name" />
						</form:select>
					</span>
				</div>
				<div id="smsTab">
					<form:textarea path="smsTemplate" readonly="${template.readonly}"></form:textarea>
				</div>
				
			</div>
			<div class="right">
			<spring:message code="Preview.action.label" var="preview_label"
				htmlEscape="false" />
			<spring:message code="Save.action.label" var="save_label"
				htmlEscape="false" />
			<spring:message code="Cancel.action.label" var="cancel_label"
				htmlEscape="false" />
			<spring:message code="SendTestNotification.action.label" var="send_label"
				htmlEscape="false" />
			<spring:message code="Activate.action.label" var="activate_label"
				htmlEscape="false" />				
				
			<c:if test="${not template.readonly}">
				<input type="button" id="test_btn" value="${send_label}" />
			</c:if>
			
			<input type="button" id="preview_btn" value="${preview_label}" />
			<input type = "hidden" id="action" name="action" value="" />
			<c:choose>
				<c:when test="${template.readonly}">
					<input type="button" id="activate_btn" value="${activate_label}" />
				</c:when>
				<c:otherwise>
					<input type="button" id="save_btn" value="${save_label}"/>
				</c:otherwise>
			</c:choose>
			<input type="button" value="${cancel_label}" onclick="location.href='${template_url}?locale=${template.notificationTemplate.locale}'"/>
			</div>
			
			</form:form>
			
			<!-- Preview modal dialog -->
		
		<spring:message code="PreviewTemplate.header.title" var="preview_label" arguments="${template.notificationTemplate.name}"
			htmlEscape="false" />
		<div id="preview_dialog" title="${preview_label}">
			<p></p>
			<br/>
			<div class="right">
			<spring:message code="Close.action.label" var="close_label"
				htmlEscape="false" />
			<input type="button" id="close" value="${close_label}" onclick="$('#preview_dialog').dialog('close');" />
			</div>
		</div>
		<spring:message code="SendTestNotification.header.title" var="sendTest_label"
			htmlEscape="false" />
		<div id="test_dialog" title="${sendTest_label}">
			<div id="msg">
				
			</div>
			<p>
				<spring:message code="TestNotificationMergeVarDescription.txt" var="mergevar_label"
					htmlEscape="false" />
				${mergevar_label}
			</p>
				<spring:url value="/templates/testNotification" var="notification_url"/>
	   			<form action="${notification_url}" id="testVarsForm" method="POST">
				<input type="hidden" id="name" value="${template.notificationTemplate.name}"/>
				<input type="hidden" id="locale" value="${template.notificationTemplate.locale}"/>
				<table id="varTable" class="bordered">
					<thead>
					<tr>
						<spring:message code="MergeVariable.header.label" var="mergevar_label"
							htmlEscape="false" />
						<spring:message code="MergeValue.header.label" var="mergevalue_label"
							htmlEscape="false" />
						<th>${mergevar_label}</th>
						<th>${mergevalue_label}</th>
					</tr>
					</thead>
					<tbody>
					</tbody>
				</table>
				<spring:message code="TestNotificationMergeVar.instruction.txt" var="mergevar_instr"
					htmlEscape="false" />
				<spring:message code="Send.action.label" var="send_label"
					htmlEscape="false" />
				<spring:message code="Cancel.action.label" var="cancel_label"
					htmlEscape="false" />
				<div>
				${mergevar_instr}
				</div>
				<div id="sendDiv" class="right">
					<input type ="button" id="sendData" value="${send_label}"/>
					<input type ="button" id="cancel" value="${cancel_label}" onclick="$('#test_dialog').dialog('close');"/>
				</div>
	   			</form>
		</div>
	</div>
		
	</body>
</html>